<html>
<head>
    <meta charset="UTF-8" />
    <title>Démo</title>
</head>
<body>
    <script type="module">
    import { h, registerElement, Datatype } from './index.js';

    registerElement("button",function(props, options){
        if(typeof options != "object"){options = {};}
        let X, Y;
        return h({elt:"input", type:"button", on:{
            click:options.click || function(){console.log("click")},
            drag:{
                startDrag:function(e){let t = e.target; t.style.position = "absolute"; let bb = t.getBoundingClientRect(); X=e.clientX-bb.x; Y=e.clientY-bb.y; },
                drag:function(e){let t = e.target; t.style.left = e.clientX -X + "px";t.style.top = e.clientY -Y + "px";},
                endDrag:function(e){let t = e.target; t.style.position =t.style.left =t.style.top = "";}
            }
        }, value:options.name || "Click me" })
    });
    
    document.body.appendChild(h({elt:"div", Text:"Langue", child:[
        {elt:"button",style:{fontWeight:"bold"}, hoverTitle:"coucou", opt:{name:"français", click:trFrench}},
        {elt:"button", opt:{name:"english", click:trEnglish}, tradHover:"hello"}
    ]}));


    h.addHover({style:{backgroundColor:"#F80",border:"1px solid #444",transform: "translate(-50%, 0px)"} }, {marginV:2});

    function trEnglish(){
        h.setTranslations({name:"name",hello:"hello"});
        h.translatePage();
    }
    function trFrench(){
        h.setTranslations({name:"nom",hello:"salut"});
        h.translatePage();
    }
    trFrench();

    //datatype check
    let dt = {t:"object", properties:[
        {n:"name", t:"string"},
        {n:"age", t:"int8", min:6, max:120, step:1, opt:1},
        {n:"taille", t:"enum", values:["petit","moyen","grand"], opt:1, cond:["||",["age",">","18"], ["couleur", "!=", undefined]]},
        {n:"couleur", t:"color3", opt:true},
        {n:"naissance", t:"dateTime"}
    ]};
    let cdt = new Datatype(dt);
    let buff = cdt.toBinary({name:"toto", age:8, taille:1, naissance:new Date(1991,10,8,3,30) })
    let o = window["o"] = cdt.fromBinary(buff);
    console.log(buff, o);

    document.body.appendChild(cdt.getInputUI(o, {translate:true} )); //{onchange:console.warn, oninput:console.log} ));


    dt = {t:"array", type:{t:"cleverInt"}};
    cdt = new Datatype(dt);
    let a = [0,15,-20,458,66666,(1<<30)*4];
    buff = cdt.toBinary(a);
    console.log(a, buff, cdt.fromBinary(buff));


    </script>
</body>
</html>